//===========================================================================
// File		: KlibClients.h
// Author	: Cdric Lallain
// 
// Version	: 2.0
// Purpose	: Sdk
//
// Platform	: PC Win32
//===========================================================================




/////////////////////////////////////////////////////////////////////////////
// Include Guard :
#ifndef __KLIENTS_CLIENTS_SDK__
#define __KLIENTS_CLIENTS_SDK__



/////////////////////////////////////////////////////////////////////////////
// Structure :
struct COLOR	{ char r, g, b, a ; } ;
struct FONT		{ const char *pfont ; int size, style ; } ;


/////////////////////////////////////////////////////////////////////////////
//
//				Class Declaration
//
/////////////////////////////////////////////////////////////////////////////


class KlientsClientsSdk : public KlientsSdk
{
//---------------------------------------------------------------------------------------------------------//
// Public methods :
public:
					KlientsClientsSdk	(const char *pname)													;

	virtual void	onSystemEvent		(KlientsSystemEvents event, const EventsData *pdata)				;

//---------------------------------------------------------------------------------------------------------//
// Protected methods (Klient's methods) :
protected:

			// Socket methods :
	virtual void		close				()																					;
	virtual void		connect				()																					;
	virtual bool		isConnected			()																					;
	virtual void		recordConnection	(const char *pserver, int port, bool set_to_default = true)							;
	virtual void		send				(const char *pformat, ...)															;

			// Configuration methods :
	virtual	void		recordColor			(const char *pcolname, const char *pdescr, int defr, int defg, int defb)			;
	virtual	COLOR		getColor			(const char *pcolname)																;
	virtual	void		setColor			(const char *pcolname, int r, int g, int b)											;
	virtual	void		recordFont			(const char *pfntname, const char *pdescr, const char *pfont, int size, int style)	;
	virtual	FONT		getFont				(const char *pfntname)																;
	virtual	void		setFont				(const char *pfntname, const char *pfont, int size, int style)						;

	virtual	bool		checkEvent			(const char *pevent)																;
	virtual	int			readConfigStr		(const char *pfield, char *pbuf, int size, const char *pdef)						;
	virtual	int			readConfigInt		(const char *pfield, int defval)													;
	virtual	bool		readConfigBool		(const char *pfield, bool defval)													;
	virtual	float		readConfigFloat		(const char *pfield, float defval)													;
	virtual	void		writeConfigStr		(const char *pfield, const char *pval)												;
	virtual	void		writeConfigInt		(const char *pfield, int value)														;
	virtual	void		writeConfigBool		(const char *pfield, bool value)													;
	virtual	void 		writeConfigFloat	(const char *pfield, float value)													;

			// Plugins methods :
	virtual bool		usePlugin			(const char *pplugname)																;
	virtual const char*	getPlugsList		()																					;
//---------------------------------------------------------------------------------------------------------//
} ;


#endif
