//===========================================================================
// File		: KlibPlugsFactory.h
// Author	: Cdric Lallain
// 
// Version	: 2.0
// Purpose	: Sdk
//
// Platform	: PC Win32
//===========================================================================




/////////////////////////////////////////////////////////////////////////////
// Include Guard :
#ifndef __KLIENTS_PLUGS_FACTORY__
#define __KLIENTS_PLUGS_FACTORY__


/////////////////////////////////////////////////////////////////////////////
// Plugin's type :
/////////////////////////////////////////////////////////////////////////////
enum KlientsType
{
	KLIENTS_TYPE_ERROR		= 0	,

	KLIENTS_SYSTEM_PLUGIN	= 1 ,

	KLIENTS_MAIN_PLUGIN		= 7 ,
	KLIENTS_ADDINS_PLUGIN	= 8 ,
	KLIENTS_INOUT_PLUGIN	= 9
} ;


/////////////////////////////////////////////////////////////////////////////
//
//				Class Declaration
//
/////////////////////////////////////////////////////////////////////////////


class KlientsPlugsFactory
{
//-------------------------------------------------------------------------//
// Public methods :
public:
						KlientsPlugsFactory	()								;

	virtual void		init				()							= 0	;
	virtual	void		term				()							= 0	;

	virtual	const char*	name				()					const	= 0	;
	virtual	float		version				()					const	= 0	;
	virtual KlientsType	type				()					const	= 0 ;
	virtual const char*	author				()					const	= 0	;
	virtual const char*	shortDescription	()					const	= 0 ;
	virtual	const char*	getHelpFile			()					const	= 0	;

	virtual KlientsSdk*	newSession			(const char *pname)			= 0	;
	virtual void		deleteSession		(KlientsSdk *psession)		= 0	;
//-------------------------------------------------------------------------//
} ;


#endif

