//===========================================================================
// File		: KlibGfx.h
// Author	: Cdric Lallain
// 
// Version	: 2.0
// Purpose	: Sdk
//
// Platform	: PC Win32
//===========================================================================




/////////////////////////////////////////////////////////////////////////////
// Include Guard :
#ifndef __KLIENTS_SUPER_SDK__
#define __KLIENTS_SUPER_SDK__




/////////////////////////////////////////////////////////////////////////////
//
//				Class Declaration
//
/////////////////////////////////////////////////////////////////////////////


class KlientsSdk
{
//-------------------------------------------------------------------------------------//
// Public methods :
public:
						KlientsSdk			(const char *pname)																		;
	virtual				~KlientsSdk			()																						;

			const char*	name				()																			const		;

	virtual void		init				()																						;
	virtual	void		term				()																						;

	virtual bool		hasSetupWindow		()																						;
	virtual	void		createSetupWindow	(HWND window)																			;
	virtual	void		writeSetup			()																						;
	virtual	void		reloadSetup			()																						;
	virtual	void		onSetupOpen			()																						;
	virtual	void		onSetupClose		()																						;

	virtual	int			getBackupSizeNeeded	()																						;
	virtual	void		backup				(void *pbackup, int size)																;
	virtual	void		restore				(const void *pbackup, int size)															;

	virtual void		onUserEvent			(const char *pfrom, const char *ptype, const void *pdata)								;
	virtual int			onRequest			(const char *pfrom, void *pbuffer, int bufsize, const char *ptype, const void *pdata)	;

//-------------------------------------------------------------------------------------//
// Protected methods (Klient's methods) :
protected:
			// System methods :
	virtual	float		getKlientsVersion	()																						;
	virtual	HWND		getKlientsWindow	()																						;
	virtual	HINSTANCE	getKlientsHInstance	()																						;
	virtual	bool		checkKeyPressed		(int key_pressed)																		;

			// System output methods :
	virtual	void		syscolor			(int r, int g, int b)																	;
	virtual	void		sysout				(const char *pformat, ...)																;

			// Tabs methods :
	virtual	HWND		createTab			(const char *plabel)																	;
	virtual	void		closeTab			(HWND tabwin)																			;
	virtual	void		highlight			(HWND tabwin, bool highlight)															;
	virtual	void		activate			(HWND tabwin)																			;
	virtual	bool		isActivated			(HWND tabwin)																			;
	virtual	void		setLabel			(HWND tabwin, const char *plabel)														;

			// Plugins methods :
	virtual const char*	getAuthor			(const char *pplugname)																	;
	virtual float		getVersion			(const char *pplugname)																	;
	virtual void		sendEvent			(const char *ptarget, const char *ptype, const void *pdata)								;
	virtual int			sendRequest			(const char *ptarget, void *pbuffer, int bufsize, const char *ptype, const void *pdata)	;
	virtual void		autoUpdate			(const char *pnewplugfile)																;

//-------------------------------------------------------------------------------------//
// Private property :
private:
	char	*pname	;

//-------------------------------------------------------------------------------------//
} ;


#endif

