//===========================================================================
// File		: KlibSystem.h
// Author	: Cdric Lallain
// 
// Version	: 2.0
// Purpose	: Sdk
//
// Platform	: PC Win32
//===========================================================================




/////////////////////////////////////////////////////////////////////////////
// Include Guard :
#ifndef __KLIENTS_SYSTEM_SDK__
#define __KLIENTS_SYSTEM_SDK__




/////////////////////////////////////////////////////////////////////////////
//
//				Class Declaration
//
/////////////////////////////////////////////////////////////////////////////


class KlientsSystemSdk : public KlientsSdk
{
//---------------------------------------------------------------------------------------------------------------------//
// Public methods :
public:
						KlientsSystemSdk	(const char *pname)															;

	virtual bool		onWindowMessage		(HWND mainwin, UINT msg, WPARAM wparam, LPARAM lparam)						;
	virtual bool		onCheckKeyPressed	(int keypressed)															;

	virtual void		onNewClient			(const char *pclient)														;
	virtual void		onSystemEvent		(const char *pclient, KlientsSystemEvents event, const EventsData *pdata)	;
	virtual const char*	onReceivedData		(const char *pclient, const char *pdata)									;
	virtual bool		onEvent				(const char *pclient, int num, const char *pevt, const EventsData *pdata)	;
	virtual const char*	onDataToSend		(const char *pclient, const char *pdata)									;

	virtual	bool		onCommandLine		(const char *pline)															;
	virtual void		onHelpRequest		()																			;

//---------------------------------------------------------------------------------------------------------------------//
// Protected methods (Klient's methods) :
protected:
	virtual void		send				(const char *pclient, const char *pformat, ...)								;

	virtual	int			readConfigStr		(const char *pfield, char *pbuf, int size, const char *pdef)				;
	virtual	int			readConfigInt		(const char *pfield, int defval)											;
	virtual	bool		readConfigBool		(const char *pfield, bool defval)											;
	virtual	float		readConfigFloat		(const char *pfield, float defval)											;
	virtual	void		writeConfigStr		(const char *pfield, const char *pval)										;
	virtual	void		writeConfigInt		(const char *pfield, int value)												;
	virtual	void		writeConfigBool		(const char *pfield, bool value)											;
	virtual	void 		writeConfigFloat	(const char *pfield, float value)											;

//---------------------------------------------------------------------------------------------------------------------//
} ;


#endif
